/* massXpert - the true massist's program.
   --------------------------------------
   Copyright(C) 2006,2007 Filippo Rusconi

   http://www.massxpert.org/massXpert

   This file is part of the massXpert project.

   The massxpert project is the successor to the "GNU polyxmass"
   project that is an official GNU project package(see
   www.gnu.org). The massXpert project is not endorsed by the GNU
   project, although it is released ---in its entirety--- under the
   GNU General Public License. A huge part of the code in massXpert
   is actually a C++ rewrite of code in GNU polyxmass. As such
   massXpert was started at the Centre National de la Recherche
   Scientifique(FRANCE), that granted me the formal authorization to
   publish it under this Free Software License.

   This software is free software; you can redistribute it and/or
   modify it under the terms of the GNU  General Public
   License version 3, as published by the Free Software Foundation.
   

   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this software; if not, write to the

   Free Software Foundation, Inc.,

   51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
*/


#ifndef CLEAVE_OPTIONS_HPP
#define CLEAVE_OPTIONS_HPP


/////////////////////// Local includes
#include "cleaveSpec.hpp"
#include "globals.hpp"


namespace massXpert
{

  class CleaveOptions : public CleaveSpec
  {
  private:
    int m_partials;

    // These two values have to be both positive and in increasing order
    // or equal. That is m_endIonizeLevel >= m_startIonizeLevel. Only
    // use access functions to set their values.
    int m_startIonizeLevel;
    int m_endIonizeLevel;

    bool m_sequenceEmbedded;
  
  public:
    CleaveOptions(PolChemDef *,
		   QString, QString,
		   int = 0, bool = false);
  
    CleaveOptions(const CleaveSpec &,
		   int = 0, bool = false);

    CleaveOptions(const CleaveOptions &);
  
    ~CleaveOptions();

    void clone(CleaveOptions *) const;
    void mold(const CleaveOptions &);

    void setPartials(int);
    int partials() const;

    void setStartIonizeLevel(int);
    int startIonizeLevel() const;
  
    void setEndIonizeLevel(int);
    int endIonizeLevel() const;

    void setIonizeLevels(int,int);

  
    void setSequenceEmbedded(bool);
    bool isSequenceEmbedded() const;
  };
  
} // namespace massXpert


#endif // CLEAVE_OPTIONS_HPP
